
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>数据结构基础(5)--C语言实现循环队列--静态 / 憋错料</title>

    <meta name="description" content="数据结构基础(5)--C语言实现循环队列--静态 #include&lt;stdio.h&gt; #include&lt;malloc.h&gt; #include&lt;stdbool.h&gt; typedef struct Queue{ int * PBase;//指向数组第一个元素的指针 int front;//队列头部元素下标 int rear;//队列尾部元素下标 }QUEUE; /** *初始化队列,实现队列的数组长度为6. **/ void initQueue(QUEUE * pQ) { pQ-&gt;PBase=malloc( ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">数据结构基础(5)--C语言实现循环队列--静态</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>#include&lt;stdio.h&gt;
#include&lt;malloc.h&gt;
#include&lt;stdbool.h&gt;
typedef struct Queue{
int * PBase;//指向数组第一个元素的指针
int front;//队列头部元素下标
int rear;//队列尾部元素下标
}QUEUE;
/**
*初始化队列，实现队列的数组长度为6。
**/
void initQueue(QUEUE * pQ)
{
    pQ-&gt;PBase=malloc(sizeof(int)*6);
    pQ-&gt;front=0;
    pQ-&gt;rear=0;
}
/**
判断队列是否已满
*/
bool isFull(QUEUE * pQ)
{
if((pQ-&gt;rear+1)%6==pQ-&gt;front)
{
    printf(&quot;队列已满，无法插入&quot;);
    return true;
}

return false;
}

/**
判断队列是否为空
*/

bool isEmpty(QUEUE * pQ)
{
  if(pQ-&gt;front==pQ-&gt;rear)
  {
      printf(&quot;队列为空&quot;);
      return true;
  }
return false;
  }
/**
入队
*/
bool insert(QUEUE * pQ,int val)
{
  if(isFull(pQ))
    return false;
  pQ-&gt;PBase[pQ-&gt;rear]=val;
  pQ-&gt;rear=(pQ-&gt;rear+1)%6;
  return true;
}

/**
遍历队列
*/

void traverse(QUEUE * pQ)
{
    int i=pQ-&gt;front;
    while(i!=pQ-&gt;rear)
    {
        printf(&quot;%d  &quot;,pQ-&gt;PBase[i]);
        i++;
    }
    printf(&quot;\n&quot;);
}

/**
出队
*/

bool  out_queue(QUEUE * pQ)
{
  if(isEmpty(pQ))
    return false;

  pQ-&gt;front=(pQ-&gt;front+1)%6;

}

int main()
{

QUEUE Q;
initQueue(&amp;Q);
insert(&amp;Q,1);
insert(&amp;Q,2);
insert(&amp;Q,3);
insert(&amp;Q,4);
insert(&amp;Q,5);
insert(&amp;Q,6);
traverse(&amp;Q);
out_queue(&amp;Q);
traverse(&amp;Q);
return 0;
}
</pre>
<p>涉及的知识点讲解见上一篇文章:<a href="http://blog.csdn.net/davidluo001/article/details/46596553" rel="external nofollow noreferrer">http://blog.csdn.net/davidluo001/article/details/46596553</a></p>
<p>关键:1.少用一个位置,用于区分队列是空还是满.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 23:22:10 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>数据结构基础(5)--C语言实现循环队列--静态的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41VEPGM.html" rel="bookmark">数据结构之---C语言实现循环队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				//循环队列 //杨鑫 #include &lt;stdio.h&gt; #include &lt;stdlib.h&gt; #define MAXSIZE 10 typedef int QElemType; typedef struct queue { QElemType elem[MAXSIZE]; int front; int rear; }SqQueue; //定义队头 int init_Queue(SqQueue **q) //初始化 { (*q)-&gt;front = 0; (*q)-&gt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mmmj9DM.html" rel="bookmark">C语言实现循环队列（基本操作及图示）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				-------------------------------------------- 如果使用顺序表作为队列的话,当处于右图状态则不能继续插入新的队尾元素,否则会因为数组越界而导致程序代码被破坏. 由此产生了由链表实现的循环队列,只有队列未满时才可以插入新的队尾元素. - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyRrZj0.html" rel="bookmark">数据结构实验4：C&plus;&plus;实现循环队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				实验4 4.1 实验目的 熟练掌握队列的顺序存储结构和链式存储结构. 熟练掌握队列的有关算法设计,并在循环顺序队列和链队列上实现. 根据具体给定的需求,合理设计并实现相关结构和算法. 4.2 实验要求 4.2.1 循环顺序队列的实验要求 循环顺序队列结构和运算定义,算法的实现以库文件方式实现,不得在测试主程序中直接实现: 实验程序有较好可读性,各运算和变量的命名直观易懂,符合软件工程要求: 程序有适当的注释. 4.3 实验任务 4.3.1 循环顺序队列实验任务 编写算法实现下列问题的求解. &lt;1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vlvKoM.html" rel="bookmark">数据结构总结系列（四）&mdash;&mdash;循环队列之杨辉三角</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天我们来写一个循环队列的应用哦! 解决的是杨辉三角问题~~ 对于这样一个上下多层之间有密切联系的数据,如果只是用数组和循环来解决的话,显然会浪费大量的空间和时间, 所以我们用队列来解决这一问题: 之所以选用循环队列也是因为它对于空间的利用是非常有效的,方便我们的工作: 开始定义结构体: typedef struct //定义循环队列 { int data[MAXMIZE]; int Front; int Rear; }RollQueue; 这里的最大值(MAXMIZE)大家可以用宏定义来自己定			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MG9mgZ3.html" rel="bookmark">数据结构java学习（三）循环队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				@TOC 和栈一样,队列也是表,但是使用队列的特点是先进先出. 队列模型 \(\color{black}{队列的基本操作是入队,它是在表的末端插入一个元素,和出队,它是删除在表开头的一个元素}\) graph LR A[&lt;kbd&gt;入队&lt;/kbd&gt;] --&gt; b[队列] b[队列] --&gt; c[&lt;kbd&gt;出队&lt;/kbd&gt;] 队列的循环数组实现 实现队列的类 import java.util.Arrays; /** * @author 李正阳 * @			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e7Omg4.html" rel="bookmark">【数据结构-队列】循环队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于循环队列 循环队列就是像一个圈一样,可以一直不停的入队和出队,例如:队列已经满了,如果执行一次出队操作,队列头部就空出来了,这时候就可以把元素继续插入空出来的那里,头指针向后移第二个元素就变成的队列的头,上一个对头就变成了队尾 下图中:此时队列已经满了,但是当把12出队后,head指针会指向第1个位置,这是再忘队列中插入元素的,tail就会指向0的位置,然后把元素插入到0的位置. 组成循环队列需要的元素 int data[COUNT];//存放元素 int head;//头指针 int ta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a1B5A0.html" rel="bookmark">数据结构算法C语言实现（十二）--- 3&period;4循环队列&amp;amp&semi;队列的顺序表示和实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.简述 空队列的处理方法:1.另设一个标志位以区别队列是空还是满:2.少用一个元素空间,约定以队列头指针在队尾指针下一位置上作为队列呈满的状态的标志. 二.头文件 1 //3_4_part1.h 2 /** 3 author:zhaoyu 4 email:[email protected] 5 date:2016-6-9 6 note:realize my textbook &lt;&lt;数据结构(C语言版)&gt;&gt; 7 */ 8 //Page 64 9 #include &lt;cstdio			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47DAp9M.html" rel="bookmark">数据结构基础（5）--队列和循环队列详解--静态方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				队列的具体应用: 所有和事件有关的操作都有队列的影子. (例如操作系统认为先进来的先处理) 定义: 一种可是实现&quot;先进先出&quot;的存储结构 分类: 链式队列:用链表实现 静态队列:用数组实现 静态队列通常都必须是循环队列,为了减少 内存浪费. 循环队列 : 1.静态队列为什么必须是循环队列 如果用传统意义的数组实现队列,无论入队还是出队,rear和front指针只能+不能-: 比 F元素下标小的的数组元素下标就浪费了. 循环队列怎么用呢? 当出现这种情况时,如果仍然需要插入元素,那么f指向			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Jbbvn4.html" rel="bookmark">数据结构：循环队列（C语言实现）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				生活中有非常多队列的影子,比方打饭排队,买火车票排队问题等,能够说与时间相关的问题,一般都会涉及到队列问题:从生活中,能够抽象出队列的概念,队列就是一个能够实现&quot;先进先出&quot;的存储结构.队列分为链式队列和静态队列:静态队列一般用数组来实现,但此时的队列必须是循环队列,否则会造成巨大的内存浪费:链式队列是用链表来实现队列的.这里讲的是循环队列,首先我们必须明确以下几个问题 一.循环队列的基础知识 1.循环队列须要几个參数来确定 循环队列须要2个參数,front和rear 2.循环队列各个參			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXRjG3.html" rel="bookmark" class="title">ubuntu 安装LNMP</a>
					<div>
						How To Install Linux, nginx, MySQL, PHP (LEMP) stack on Ubuntu 12.04 PostedJune 13, 2012 802.8kviews ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MEaKXM.html" rel="bookmark" class="title">【转载】为什么CPU有多层缓存</a>
					<div>
						原文:为什么CPU有多层缓存 http://mp.weixin.qq.com/s?__biz=MzI1NDM2Nzg5Mw==&amp;mid=2247483712&amp;idx=1&amp;sn= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvQZx0.html" rel="bookmark" class="title">导航菜单滑动动画</a>
					<div>
						用jquery实现百度新闻导航菜单滑动动画 前言 前两天,群里有人问百度新闻导航是如何实现的,当时由于忙于工作,没有来得及细看,恰好今天有空闲时间,索性就实现一下这个效果吧: 思路与步骤 1.利用UL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDG2b0.html" rel="bookmark" class="title">&lbrack;Java5新特性&rsqb;自动装箱&sol;拆箱</a>
					<div>
						自动装箱/拆箱概述 Java中具有基本类型(int,double,float,long,boolean,char,byte,short)和基本类型包装类(Integer,Double,Float,Lo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49blAJM.html" rel="bookmark" class="title">how to git</a>
					<div>
						git init #local branch,fail with githubgit add readme.mdgit commit -m &quot;first commit&quot;git re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRWAR0.html" rel="bookmark" class="title">50条大牛C&plus;&plus;编程开发学习建议</a>
					<div>
						每个从事C++开发的朋友相信都能给后来者一些建议,但是真正为此进行大致总结的很少.本文就给出了网上流传的对C++编程开发学习的50条建议,总结的还是相当不错的,编程学习者(不仅限于C++学习者)如果真 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDlmj3.html" rel="bookmark" class="title">Activity回退栈使用</a>
					<div>
						当一个APP启动时,系统会为这个APP创建一个回退栈(任务),用于保存APP所有已经创建的额Activity.当应用启动时,主窗口将第一个被压入回退栈,当显示本应用的其他窗口时,也会按显示顺序创建窗口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0enO1D3.html" rel="bookmark" class="title">1 duilib 自绘标题 最大化图标显示bug ----WindowImplBase的bug</a>
					<div>
						窗口最大化之后有两个问题, 1.最大化按钮的样式还是没变,正确的样式应该是这样的 2.再次点击最大化按钮,不能还原到正常大小. 这个是WindowImplBase的bug,已经提交给官方有一段时间了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415Bxv4.html" rel="bookmark" class="title">uva 10304 - Optimal Binary Search Tree  区间dp</a>
					<div>
						题目链接 给n个数, 这n个数的值是从小到大的, 给出个n个数的出现次数. 然后用他们组成一个bst.访问每一个数的代价是这个点的深度*这个点访问的次数. 问你代价最小值是多少. 区间dp的时候, 如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvXrv3.html" rel="bookmark" class="title">MongoDB 数据迁移和同步</a>
					<div>
						MongoDB 数据迁移和同步 MongoDB的数据同步 复制 mongodb的复制至少需要两个实例.其中一个是主节点master,负责处理客户端请求,其余的都是slave,负责从master上复制数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49rKpvM.html" rel="bookmark" class="title">sgu 455&period; Sequence analysis （floyd 判圈算法，O&lpar;1&rpar;空间复杂度求循环节）</a>
					<div>
						455. Sequence analysis Time limit per test: 1 second(s)Memory limit: 4096 kilobytes input: standardo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPD7kPM.html" rel="bookmark" class="title">sh&lowbar;Spring整合Hibernate</a>
					<div>
						分别介绍了Sping和Hibernate,下面是将它们整合到一块去了.   一.Hibernate内容 1.创建PO类. package cn.tgb.domain; //User实体 public  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mw6D0.html" rel="bookmark" class="title">Windows平台快速的创建一个指定大小的文件</a>
					<div>
						有时,我们需要快速创建一个指定大小的文件,做系统测试使用,我们指定在Linux平台中可以使用如下命令: 创建一个100M的空文件 dd if=/dev/zero of=hello.txt bs=100 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RwaD53.html" rel="bookmark" class="title">内核中的 likely&lpar;&rpar; 与 unlikely&lpar;&rpar;</a>
					<div>
						内核中的 likely() 与 unlikely() 在 2.6 内核中,随处可以见到 likely() 和 unlikely() 的身影,那么为什么要用它们?它们之间有什么区别? 首先要明确: if ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWKLQ3.html" rel="bookmark" class="title">DOS命令将黑框中查询到的信息保存到TXT等文件中</a>
					<div>
						DOS命令将黑框中查询到的信息保存到TXT等文件中,布布扣,bubuko.com					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjqr63.html" rel="bookmark" class="title">Linux网络属性配置&mdash;&mdash;ifcfg命令家族</a>
					<div>
						ifconfig命令 功能:可以手动启动.查看和修改网络接口的相关参数. 用法: ifconfig                                     //查看默认显示激活状态的网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AW1mD0.html" rel="bookmark" class="title">hdu 1387（Team Queue） STL</a>
					<div>
						Team Queue Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezBDD3.html" rel="bookmark" class="title">Hadoop学习Day20---ZooKeeper系列（四）</a>
					<div>
						使用ZooKeeper来构建应用 在一定程度上了解ZooKeeper之后,我们接下来要用ZooKeeper编写一些有用的应用程序. 一.配置服务 配置服务是分布式应用所需要的基本服务之一,它使集群中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6XwjZ3.html" rel="bookmark" class="title">makefile中的shell编程注意点</a>
					<div>
						参考:http://blog.csdn.net/wanglang3081/article/details/49423105 (1)Makefile本质上来讲也是shell脚本,即每条command都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YLmbrM.html" rel="bookmark" class="title">2月15日，OpenCenter踏步而来</a>
					<div>
						距离2015年的情人节越来越近,很多的人早早地就在等待这个情人节,期望情人节快点到来,那小编作为一枚单身妹子对情人节可不感冒,小编等待的是另外一个重要的日子2月15日,这是个什么重要的日子呢?那就是O ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
